// *****************************
// ***  B a c k g r o u n d  ***
// *****************************
// ***    by Fuzzware 2001   ***
// *****************************
// 
// Oggetti per creare vari tipi
// di sfondo

#include "background.h"

// *****************************
// *****************************
// ***  B a c k g r o u n d  ***
// *****************************
// *****************************

Background::Background() {
}

Background::~Background() {
}

// *****************************
// *****************************
// ***   S t a r f i e l d   ***
// *****************************
// *****************************

Starfield::Starfield() {
	ready1=ready2=false;
}

Starfield::~Starfield() {
	kill();
}

void Starfield::create(float rr,float lm,int num,char *fname,float sz) {
	if (ready1) return;
	list1=glGenLists(1);
	float r,theta,fi;
	float x,y,z,lum;
	glNewList(list1,GL_COMPILE);
	glPointSize(2.0f);
	glBegin(GL_POINTS);
	for(int i=0;i<num/4;i++) {
			r=rr*pow(float(rand()%1000)/1000.0,0.333f);
			theta=2*M_PI*float((rand()%1000)-500.0)/1000.0;
			fi=asin(2*float((rand()%1000)-500.0)/1000.0);
			x=r*cos(theta)*cos(fi);
			z=r*sin(theta)*cos(fi);
			y=r*sin(fi);
			lum=lm*((float)abs(rand()%1000))/1000.0f;
			lum=lum*lum;
			glColor3f(lum,lum,lum);
			glVertex3f(x,y,z);
	}
	glEnd();
	glPointSize(1.5f);
	glBegin(GL_POINTS);
	for(int i=num/4;i<num/2;i++) {
			r=rr*pow(float(rand()%1000)/1000.0,0.333f);
			theta=2*M_PI*float((rand()%1000)-500.0)/1000.0;
			fi=asin(2*float((rand()%1000)-500.0)/1000.0);
			x=r*cos(theta)*cos(fi);
			z=r*sin(theta)*cos(fi);
			y=r*sin(fi);
			lum=lm*((float)abs(rand()%1000))/1000.0f;
			lum=lum*lum;
			glColor3f(lum,lum,lum);
			glVertex3f(x,y,z);
	}
	glEnd();
	glPointSize(1.0f);
	glBegin(GL_POINTS);
	for(int i=num/2;i<num;i++) {
			r=rr*pow(float(rand()%1000)/1000.0,0.333f);
			theta=2*M_PI*float((rand()%1000)-500.0)/1000.0;
			fi=asin(2*float((rand()%1000)-500.0)/1000.0);
			x=r*cos(theta)*cos(fi);
			z=r*sin(theta)*cos(fi);
			y=r*sin(fi);
			lum=lm*((float)abs(rand()%1000))/1000.0f;
			lum=lum*lum;
			glColor3f(lum,lum,lum);
			glVertex3f(x,y,z);
	}
	glEnd();
	glEndList();
	ready1=true;
	if (fname==0) return;
	// Disegna poligoni
	map.setDiffuseMap(fname,DETAIL1);	
	list2=glGenLists(1);
	glNewList(list2,GL_COMPILE);
	Vector v1,v2,v3;
	glBegin(GL_QUADS);
	for(int i=0;i<4;i++)
		for(int j=0;j<4;j++) {
				r=rr;
				theta=2*M_PI*float((rand()%1000)-500.0)/1000.0;
				fi=asin(2*float((rand()%1000)-500.0)/1000.0);
				x=r*cos(theta)*cos(fi);
				z=r*sin(theta)*cos(fi);
				y=r*sin(fi);
				v1.set(x,y,z);
				v1.plane(v2,v3);
				v2.normalize();
				v3.normalize();
				v2=mul(sz,v2);
				v3=mul(sz,v3);
				glTexCoord2f(0.25f*float(i),0.25*float(j));
				glVertex3f(x,y,z);
				glTexCoord2f(0.25f*float(i+1),0.25*float(j));
				glVertex3f(x+v2.x,y+v2.y,z+v2.z);
				glTexCoord2f(0.25f*float(i+1),0.25*float(j+1));
				glVertex3f(x+v2.x+v3.x,y+v2.y+v3.y,z+v2.z+v3.z);
				glTexCoord2f(0.25f*float(i),0.25*float(j+1));
				glVertex3f(x+v3.x,y+v3.y,z+v3.z);
		}
	glEnd();
	glEndList();
	ready2=true;
}

void Starfield::kill() {
	if (ready1) glDeleteLists(list1,1);
	if (ready2) {
		glDeleteLists(list2,1);
		map.kill();
	}
}

void Starfield::render() {
	if (!(ready1||ready2)) return;
	glDepthMask(GL_FALSE);
	glDisable(GL_LIGHTING);
	glEnable(GL_COLOR_MATERIAL);
	glEnable(GL_POINT_SMOOTH);
	glDisable(GL_TEXTURE_2D);
	glCallList(list1);
	glDisable(GL_POINT_SMOOTH);
	glDisable(GL_COLOR_MATERIAL);
	if (ready2) {
		glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL);
		glBlendFunc(GL_ONE,GL_ONE);
		map.apply();
		glCallList(list2);
		glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
		glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
	}
	glEnable(GL_LIGHTING);
	glDepthMask(GL_TRUE);
}

int Starfield::id() {
	return STARFIELD;
}

