// *****************************
// ***     D r i v e r s     ***
// *****************************
// ***    by Fuzzware 2001   ***
// *****************************
// 
// Inizializzazione del display,
// del suono

#ifndef DISPLAY_H
#define DISPLAY_H

#include "fmod.h"
#include "common.h"
#include "image.h"

#define WNDCLSNAME "DisplayOGL"
LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);

class Display {
	HWND winHandle;
	HDC devHandle;
	HGLRC renHandle;
	HINSTANCE hInst;
	int wscr,hscr;
	int bpp;
	bool vsync;
	bool full;
	char *title;
public:
	Display();
	~Display();
	void setMode(int,int,int,bool,bool,char*);
	bool enableOpenGL();
	void disableOpenGL();
	void resizeScene(int,int);
	void screenShot();
	int getWidth();
	int getHeight();
	HDC getHDC();
};

enum keydefs {
	k_SLASH=1,k_1,k_2,k_3,k_4,k_5,k_6,k_7,k_8,k_9,k_0,k_APICE,k_IACC,k_BACK,
	k_TAB,k_Q,k_W,k_E,k_R,k_T,k_Y,k_U,k_I,k_O,k_P,k_EACC,k_PIU,k_INVIO,
	k_CAPS,k_A,k_S,k_D,k_F,k_G,k_H,k_J,k_K,k_L,k_OACC,k_AACC,k_UACC,
	k_LSHIFT,k_MIN,k_Z,k_X,k_C,k_V,k_B,k_N,k_M,k_PTVIRG,k_2PT,k_MENO,k_RSHIFT,
	k_LCTRL,k_ALT,k_SPAZIO,k_ALTGR,k_RCTRL,
	k_UP,k_DOWN,k_LEFT,k_RIGHT,k_F1,k_F2,k_F3,k_F4,k_F5,k_F6,k_F7,k_F8,k_F9,k_F10,k_F11,k_F12,
	k_LAST
};

class Keyboard {
	bool keys[k_LAST];
	bool push[k_LAST];
public:
	Keyboard();
	~Keyboard();
	void keyDown(int,bool);
	bool readKey(int);
	bool readPush(int);
};

class Sound {
public:
	Sound();
	~Sound();
	void playSong(char*);
};

extern Display disp;
extern Keyboard kbd;
extern Sound snd;

#endif