// *****************************
// ***       F o n t s       ***
// *****************************
// ***    by Fuzzware 2001   ***
// *****************************
// 
// Generazione e stampa di bitmap
// characters con ogl

#include "fonts.h"

Font::Font() {
	base=0;
	ready=false;
	gmf=new GLYPHMETRICSFLOAT[96];
}

Font::~Font() {
	if (ready) {
		kill();
		delete[] gmf;
	}
}

bool Font::buildBitmapFont(HDC devHandle, char *name,int h) {
	if (ready) return false;
	HFONT fnt;
	base=glGenLists(96);					// Storage For 96 Characters
	fnt=CreateFont(		-h,				// Height Of Font
				0,				// Width Of Font
				0,				// Angle Of Escapement
				0,				// Orientation Angle
				FW_BOLD,			// Font Weight (number 0-1000)
				FALSE,				// Italic
				FALSE,				// Underline
				FALSE,				// Strikeout
				ANSI_CHARSET,			// Character Set Identifier
				OUT_TT_PRECIS,			// Output Precision
				CLIP_DEFAULT_PRECIS,		// Clipping Precision
				ANTIALIASED_QUALITY,		// Output Quality
				FF_DONTCARE|DEFAULT_PITCH,	// Family And Pitch
				name);			// Font Name
	if (fnt==NULL) {
		kill();
		return false;
	}
	SelectObject(devHandle,fnt);
	wglUseFontBitmaps(devHandle,32,96,base);		// Builds 96 Characters Starting At Character 32 ( NEW )
	ready=true;
	return true;
}

bool Font::buildOutlineFont(HDC devHandle, char *name,int h) {
	if (ready) return false;
	HFONT fnt;
	base=glGenLists(96);					// Storage For 96 Characters
	fnt=CreateFont(		-h,				// Height Of Font
				0,				// Width Of Font
				0,				// Angle Of Escapement
				0,				// Orientation Angle
				FW_BOLD,			// Font Weight (number 0-1000)
				FALSE,				// Italic
				FALSE,				// Underline
				FALSE,				// Strikeout
				ANSI_CHARSET,			// Character Set Identifier
				OUT_TT_PRECIS,			// Output Precision
				CLIP_DEFAULT_PRECIS,		// Clipping Precision
				ANTIALIASED_QUALITY,		// Output Quality
				FF_DONTCARE|DEFAULT_PITCH,	// Family And Pitch
				name);			// Font Name
	if (fnt==NULL) {
		kill();
		return false;
	}
	SelectObject(devHandle,fnt);
	wglUseFontOutlines(devHandle,32,96,base,0.0,0.2,WGL_FONT_POLYGONS,gmf);		// Builds 96 Characters Starting At Character 32 ( NEW )
	ready=true;
	return true;
}

// RIMUOVE LE DISPLAY LISTS create per contenere i 96 caratteri
void Font::kill() {
	if (!ready) return;
 	glDeleteLists(base,96);
 	ready=false;
}

// SCRIVE A VIDEO delle stringhe con una sintassi simile a printf, in x,y
void Font::print(int x,int y,const char *fmt, ...) {
	if (!ready) return;
	char text[256];
	va_list ap;
	if (fmt==NULL) return;
	va_start(ap,fmt);					// Parses The String For Variables
	vsprintf(text, fmt, ap);				// And Converts Symbols To Actual Numbers
	va_end(ap);						// Results Are Stored In Text
	glPushAttrib(GL_LIST_BIT);				// Pushes The Display List Bits
	glRasterPos2i(x,y);
	glListBase(base-32);					// Sets The Base Character to 32
	glCallLists(strlen(text),GL_UNSIGNED_BYTE,text);
	glPopAttrib();						// Pops The Display List Bits
	return;
}

// SCRIVE A VIDEO delle stringhe con una sintassi simile a printf
void Font::print(const char *fmt, ...) {
	if (!ready) return;
	char text[256];
	va_list ap;
	if (fmt==NULL) return;
	va_start(ap,fmt);					// Parses The String For Variables
	vsprintf(text, fmt, ap);				// And Converts Symbols To Actual Numbers
	va_end(ap);						// Results Are Stored In Text
	glPushAttrib(GL_LIST_BIT);				// Pushes The Display List Bits
	glListBase(base-32);					// Sets The Base Character to 32
	glCallLists(strlen(text),GL_UNSIGNED_BYTE,text);
	glPopAttrib();						// Pops The Display List Bits
	return;
}