// *****************************
// ***       I m a g e       ***
// *****************************
// ***    by Fuzzware 2001   ***
// *****************************
// 
// Caricatore di immagini
// formato bmp

#include "image.h"

Image::Image() {
	data=new unsigned char[1];
	w=h=0;
}

Image::~Image() {
	delete[] data;
}

bool Image::loadBMP(char *fname) {
	int x,y,i;
	Win3xHeader h1;
	Win3xInfoHeader h2;	
	FILE *in=fopen(fname,"rb");
	if (!in) return false;
	// Header 1
	fread(&h1.ImageFileType,sizeof(h1.ImageFileType),1,in);
	fread(&h1.FileSize,sizeof(h1.FileSize),1,in);
	fread(&h1.Reserved1,sizeof(h1.Reserved1),1,in);
	fread(&h1.Reserved2,sizeof(h1.Reserved2),1,in);
	fread(&h1.ImageDataOffset,sizeof(h1.ImageDataOffset),1,in);
	// Header 2
	fread(&h2.HeaderSize,sizeof(h2.HeaderSize),1,in);
	fread(&h2.ImageWidth,sizeof(h2.ImageWidth),1,in);
	fread(&h2.ImageHeight,sizeof(h2.ImageHeight),1,in);
	fread(&h2.NumberOfImagePlanes,sizeof(h2.NumberOfImagePlanes),1,in);
	fread(&h2.BitsPerPixel,sizeof(h2.BitsPerPixel),1,in);
	fread(&h2.CompressionMethod,sizeof(h2.CompressionMethod),1,in);
	fread(&h2.SizeOfBitmap,sizeof(h2.SizeOfBitmap),1,in);
	fread(&h2.HorzResolution,sizeof(h2.HorzResolution),1,in);
	fread(&h2.VertResolution,sizeof(h2.VertResolution),1,in);
	fread(&h2.NumColorsUsed,sizeof(h2.NumColorsUsed),1,in);
	fread(&h2.NumSignificantColors,sizeof(h2.NumSignificantColors),1,in);
	// Load image
	w=h2.ImageWidth;
	h=h2.ImageHeight;
	delete[] data;
	data=new unsigned char[w*h*3];
	i=0;
	int cnt;
	unsigned char dummy;
	unsigned char r,g,b;
	for(y=0;y<h;y++) {
		cnt=0;
		for(x=0;x<w;x++) {
			fread(&b,sizeof(unsigned char),1,in);
			fread(&g,sizeof(unsigned char),1,in);
			fread(&r,sizeof(unsigned char),1,in);
			data[i++]=r;data[i++]=g;data[i++]=b;
			cnt+=3;
		}
		while((cnt%4)!=0) {
			fread(&dummy,sizeof(unsigned char),1,in);
			cnt++;
		}
   }
	fclose(in);
	return true;
}

void Image::saveBMP(char *fname) {
	Win3xHeader header;
	Win3xInfoHeader info;
	FILE *f=fopen(fname,"wb");
	if (!f) return;
	header.ImageFileType='BM';
	header.FileSize=sizeof(header)+sizeof(info)+w*h*3;
	header.Reserved1=0;
	header.Reserved2=0;
	header.ImageDataOffset=0x36;
	info.HeaderSize=sizeof(info);
	info.ImageWidth=w;
	info.ImageHeight=h;
	info.NumberOfImagePlanes=1;
	info.BitsPerPixel=24;
	info.CompressionMethod=0;
	info.SizeOfBitmap=w*h*3;
	info.HorzResolution=0;
	info.VertResolution=0;
	info.NumColorsUsed=0;
	info.NumSignificantColors=0;
	fwrite(&header.ImageFileType,sizeof(header.ImageFileType),1,f);
	fwrite(&header.FileSize,sizeof(header.FileSize),1,f);
	fwrite(&header.Reserved1,sizeof(header.Reserved1),1,f);
	fwrite(&header.Reserved2,sizeof(header.Reserved2),1,f);
	fwrite(&header.ImageDataOffset,sizeof(header.ImageDataOffset),1,f);
	fwrite(&info.HeaderSize,sizeof(info.HeaderSize),1,f);
	fwrite(&info.ImageWidth,sizeof(info.ImageWidth),1,f);
	fwrite(&info.ImageHeight,sizeof(info.ImageHeight),1,f);
	fwrite(&info.NumberOfImagePlanes,sizeof(info.NumberOfImagePlanes),1,f);
	fwrite(&info.BitsPerPixel,sizeof(info.BitsPerPixel),1,f);
	fwrite(&info.CompressionMethod,sizeof(info.CompressionMethod),1,f);
	fwrite(&info.SizeOfBitmap,sizeof(info.SizeOfBitmap),1,f);
	fwrite(&info.HorzResolution,sizeof(info.HorzResolution),1,f);
	fwrite(&info.VertResolution,sizeof(info.VertResolution),1,f);
	fwrite(&info.NumColorsUsed,sizeof(info.NumColorsUsed),1,f);
	fwrite(&info.NumSignificantColors,sizeof(info.NumSignificantColors),1,f);
	char dummy=0;	
	for(int y=0;y<h;y++) {
		int cnt=0;
		for(int x=0;x<w;x++) {
			fwrite(&data[3*(x+y*w)+2],sizeof(unsigned char),1,f);
			fwrite(&data[3*(x+y*w)+1],sizeof(unsigned char),1,f);
			fwrite(&data[3*(x+y*w)+0],sizeof(unsigned char),1,f);
			cnt+=3;
		}
		while((cnt%4)!=0) {
			fwrite(&dummy,sizeof(unsigned char),1,f);
			cnt++;
		}
   }
	fclose(f);
}

void Image::setImage(unsigned char *buf,int wn,int hn) {
	delete[] data;
	data=buf;
	w=wn;
	h=hn;
}

int Image::getWidth() {
	return w;
}

int Image::getHeight() {
	return h;
}

unsigned char* Image::getArray() {
	return data;
}

unsigned char Image::red(int x,int y) {
	if ((x<0)||(x>=w)||(y<0)||(y>=h)) return 0;
	return data[3*(x+y*w)];
}

unsigned char Image::green(int x,int y) {
	if ((x<0)||(x>=w)||(y<0)||(y>=h)) return 0;
	return data[3*(x+y*w)+1];
}

unsigned char Image::blue(int x,int y) {
	if ((x<0)||(x>=w)||(y<0)||(y>=h)) return 0;
	return data[3*(x+y*w)+2];
}

float Image::lum(int x,int y) {
	if ((x<0)||(x>=w)||(y<0)||(y>=h)) return 0;
	return sqrt(red(x,y)*red(x,y)+green(x,y)*green(x,y)+blue(x,y)*blue(x,y))/sqrt(3);
}

void Image::scale(float fact) {
	float tmp;
	for(int i=0;i<3*w*h;i++) {
		tmp=(data[i]*fact);
		if (tmp>=255.0) data[i]=255;
		else data[i]=(unsigned char)tmp;
	}
}

void Image::resample(int wn,int hn) {
	if ((w==0)||(h==0)) return;
	if ((wn<=0)||(hn<=0)) return;
	float wscale=float(w-1)/float(wn);
	float hscale=float(h-1)/float(hn);
    unsigned char *tmp=new unsigned char[wn*hn*3];
    int ix,iy;
    float xx,yy;
    float r1,r2,r3,r4;
    float g1,g2,g3,g4;
    float b1,b2,b3,b4;
    for(int y=0;y<hn;y++) {
        yy=(y*hscale)-(int)(y*hscale);
        iy=(int)(y*hscale);
        for(int x=0;x<wn;x++) {
            xx=(x*wscale)-(int)(x*wscale);
            ix=(int)(x*wscale);
            r1=red(ix,iy);g1=green(ix,iy);b1=blue(ix,iy);
            r2=red(ix+1,iy);g2=green(ix+1,iy);b2=blue(ix+1,iy);
            r3=red(ix,iy+1);g3=green(ix,iy+1);b3=blue(ix,iy+1);
            r4=red(ix+1,iy+1);g4=green(ix+1,iy+1);b4=blue(ix+1,iy+1);
            tmp[3*(x+y*wn)+0]=(unsigned char)((r1*(1-yy)+r3*yy)*(1-xx)+(r2*(1-yy)+r4*yy)*xx);
            tmp[3*(x+y*wn)+1]=(unsigned char)((g1*(1-yy)+g3*yy)*(1-xx)+(g2*(1-yy)+g4*yy)*xx);
            tmp[3*(x+y*wn)+2]=(unsigned char)((b1*(1-yy)+b3*yy)*(1-xx)+(b2*(1-yy)+b4*yy)*xx);
        }
	}
	w=wn;h=hn;
	delete[] data;
	data=tmp;
}

void Image::invert() {
	for(int i=0;i<3*w*h;i++)
			data[i]=(unsigned char)(255-data[i]);
}

void Image::threshold(float t) {
	unsigned char col;
	for(int y=0;y<h;y++)
		for(int x=0;x<w;x++) {
        	if (lum(x,y)>=t) col=255;
            else col=0;
            data[3*(x+y*w)]=col;
			data[3*(x+y*w)+1]=col;
			data[3*(x+y*w)+2]=col;
		}
}

void Image::range(float r1,float r2) {
	unsigned char col;
	for(int y=0;y<h;y++)
		for(int x=0;x<w;x++) {
        	if ((lum(x,y)>=r1)&&(lum(x,y)<r2)) col=255;
            else col=0;
            data[3*(x+y*w)]=col;
			data[3*(x+y*w)+1]=col;
			data[3*(x+y*w)+2]=col;
		}
}

void Image::modulate(Image &i1,Image &i2) {
	if ((i1.w!=i2.w)||(i1.h!=i2.h)) return;
    delete[] data;
    w=i1.w;
    h=i1.h;
    data=new unsigned char[w*h*3];
    float tmp;
	for(int y=0;y<h;y++)
		for(int x=0;x<w;x++) {
        	tmp=float(i1.red(x,y)*i2.red(x,y))/255.0f;
            data[3*(x+y*w)+0]=(unsigned char)tmp;
        	tmp=float(i1.green(x,y)*i2.green(x,y))/255.0f;
            data[3*(x+y*w)+1]=(unsigned char)tmp;
        	tmp=float(i1.blue(x,y)*i2.blue(x,y))/255.0f;
            data[3*(x+y*w)+2]=(unsigned char)tmp;
		}
}

void Image::add(Image &img) {
	if ((img.w!=w)||(img.h!=h)) return;
	for(int y=0;y<h;y++)
		for(int x=0;x<w;x++) {
            data[3*(x+y*w)+0]+=img.red(x,y);
            data[3*(x+y*w)+1]+=img.green(x,y);
            data[3*(x+y*w)+2]+=img.blue(x,y);
		}
}

Image* Image::getSubImage(int x1,int y1,int width,int height) {
	if (width>w) width=w;
	if (height>h) height=h;
	if (x1+width>w) width=w-x1;
	if (y1+height>h) height=h-y1;
	if (x1<0) x1=0;
	if (y1<0) y1=0;
	Image *img=new Image();
	delete[] img->data;
	img->w=width;
	img->h=height;
	img->data=new unsigned char[3*img->w*img->h];
	int i=0;
	for(int y=y1;y<y1+height;y++)
		for(int x=x1;x<x1+width;x++) {
			img->data[i++]=data[3*(x+y*w)];
			img->data[i++]=data[3*(x+y*w)+1];
			img->data[i++]=data[3*(x+y*w)+2];
		}
	return img;
}

Image* Image::getTiledImage(int tx,int ty) {
	if (tx<1) tx=1;
    if (ty<1) ty=1;
	Image *img=new Image();
	delete[] img->data;
	img->w=w*tx;
	img->h=h*ty;
	img->data=new unsigned char[3*img->w*img->h];
	int i=0;
	for(int y=0;y<h*ty;y++)
		for(int x=0;x<w*tx;x++) {
			img->data[i++]=data[3*(x%w+(y%h)*w)];
			img->data[i++]=data[3*(x%w+(y%h)*w)+1];
			img->data[i++]=data[3*(x%w+(y%h)*w)+2];
		}
	return img;
}
