// *****************************
// ***       I m a g e       ***
// *****************************
// ***    by Fuzzware 2001   ***
// *****************************
// 
// Caricatore di immagini
// formato bmp

#ifndef IMAGEH
#define IMAGEH

#include <math.h>
#include <stdio.h>
#include <io.h>

class Image {
	unsigned char *data;
	int w,h;
public:
	Image();
	~Image();
	bool loadBMP(char*);
	void saveBMP(char*);
	void setImage(unsigned char*,int,int);
	int getWidth();
	int getHeight();
	unsigned char* getArray();
	unsigned char red(int,int);
	unsigned char green(int,int);
	unsigned char blue(int,int);
	float lum(int,int);
	void scale(float);
	void resample(int,int);
	void invert();
	void threshold(float);
	void range(float,float);
	void modulate(Image&,Image&);
	void add(Image&);
	Image* getSubImage(int,int,int,int);
	Image* getTiledImage(int,int);
};

struct Win3xHeader {
	short int ImageFileType;
	long int FileSize;
	short int Reserved1;
	short int Reserved2;
	long int	ImageDataOffset;
};

struct Win3xInfoHeader {
	long int HeaderSize;
	long int ImageWidth;
	long int ImageHeight;
	short int NumberOfImagePlanes;
	short int BitsPerPixel;
	long int CompressionMethod;
	long int SizeOfBitmap;
	long int HorzResolution;
	long int VertResolution;
	long int NumColorsUsed;
	long int NumSignificantColors;
};

#endif
