// *****************************
// ***      L o a d e r      ***
// *****************************
// ***    by Fuzzware 2001   ***
// *****************************
// 
// Caricatore di file 3d studio
// con vertici e materiali

#ifndef LOADERH
#define LOADERH

#include "objects.h"

// *****************************
// ***   3 d s l o a d e r   ***
// *****************************

#define MAIN3DS       0x4d4d
#define EDIT3DS       0x3d3d
#define OBJECT3DS     0x4000
#define POLYLIST      0x4100
#define VERTEXLIST    0x4110
#define FACELIST      0x4120
#define MATERIALLIST  0x4130
#define MAPPINGLIST   0x4140
#define LOCALMATRIX   0x4160
#define MATERIALS     0xAFFF
#define MATERIALNAME  0xA000
#define MATAMBIENT    0xA010
#define MATDIFFUSE    0xA020
#define MATSPECULAR   0xA030
#define MATTEXTURE    0xA200
#define MATTEXNAME    0xA300
#define MATCOLOR      0x0011

typedef struct {
  unsigned short ID;
  unsigned int length;
} ChunkHeader;

ChunkHeader getChunk(FILE*);
bool load3DS(char*,Object*);
void getObjNumber(FILE*);
void readMesh(FILE*);
void readMaterials(FILE*);

#endif
