// *****************************
// ***   M a t e r i a l s   ***
// *****************************
// ***    by Fuzzware 2001   ***
// *****************************
// 
// Incapsulamento delle propriet
// dei materiali

#ifndef MATERIALSH
#define MATERIALSH

#include "common.h"
#include "textures.h"

struct Color {
	float r,g,b,a;
	Color();
	void setColor(float,float,float,float);
};

class Material {
	Color amb;
	Color dif;
	Color spc;
	Color ems;
	float shine;
	Texture diffMap;
	Texture bumpMap1;
	Texture bumpMap2;
	Texture envMap;
	Texture glossMap;
public:
	float bump;
	float env;
	bool opaque;
	Material();
	~Material();
	void setAmbient(float,float,float,float);
	void setDiffuse(float,float,float,float);
	void setSpecular(float,float,float,float);
	void setEmissive(float,float,float,float);
	void setShininess(float);
	void setTransparency(float);
	bool setDiffuseMap(char*,int);
	bool setBumpMap(char*,int);
	bool setEnvironmentMap(char*,int);
	bool setGlossMap(char*,int);
	void applyColor();
	void applyDiffuse();
	void applyBump1();
	void applyBump2();
	void applyEnvironment();
	void applyGloss();
	void kill();
};

#endif
