// *****************************
// ***     M a t h 3 D       ***
// *****************************
// ***    by Fuzzware 2001   ***
// *****************************
// 
// Funzioni per la matematica 3D
// con vettori e matrici

#ifndef MATH3DH
#define MATH3DH

#include <stdlib.h>
#include <math.h>
#include "message.h"

struct Vector {
	float x;
	float y;
	float z;
	Vector();
	Vector(float,float,float);
	void set(float,float,float);
	void add(Vector&);
	void sub(Vector&);
	void plane(Vector&,Vector&);
	void normalize();
};

Vector mul(float,Vector&);
Vector add(Vector&,Vector&);
Vector sub(Vector&,Vector&);
float length(Vector&);
float dot(Vector&,Vector&);
Vector normalize(Vector&);
Vector cross(Vector&,Vector&);

struct Matrix {
	float a11,a12,a13,a21,a22,a23,a31,a32,a33;
	Matrix();
	Matrix(Vector&,Vector&,Vector&);
	void setRotX(float);
	void setRotY(float);
	void setRotZ(float);
	Vector xForm(Vector&);
};

Matrix mul(Matrix&,Matrix&);

class xyzSystem {
	Vector wPos;
	Vector xLoc,yLoc,zLoc;
public:
	float mat[16];
	xyzSystem();
	void reset();
	void move(float,float,float);
	void roll(float);
	void heading(float);
	void pitch(float);
	Vector getEyePoint();
	Vector getViewDir();
	Vector getUpVector();
	Vector getSideVector();
	void setEyePoint(Vector&);
	void setViewDir(Vector&);
	void setUpVector(Vector&);
	void normalize();
	void setAxis(Vector&,Vector&,Vector&);
	void apply();
};

extern float sinTab[];
extern float cosTab[];
void setupTab();

#endif
