// *****************************
// ***    R e n d e r e r    ***
// *****************************
// ***    by Fuzzware 2001   ***
// *****************************
// 
// Engine 3D che raggruppa tutte
// le funzioni implementate

#ifndef RENDERERH
#define RENDERERH

#include <float.h>
#include "common.h"
#include "drivers.h"
#include "fonts.h"
#include "objects.h"
#include "loader.h"
#include "camera.h"

struct Timer {
	bool perfTimer;
	float resolution;
	__int64 freq;
	float time;
	void init();
	void setTime();
	bool lessTime(float);
	float getTime();
};

// Callbacks
#define MAINLOOP	0
#define DRAW2D		1

class Renderer {
	Font fnt;
	World scene;
	Camera cam;
	int x01,y01,wscr1,hscr1;
	int x02,y02,wscr2,hscr2;
	int view1,view2;
	float ra,ga,ba;
	float rf,gf,bf,af;
	Timer timer;
	float maxFPS;
	bool visFPS;
	HDC devHandle;
	void (*mainLoopCall)();
	void (*draw2DCall)();
public:
	Renderer();
	~Renderer();
	bool init(HDC);
	void unInit();
	void addObject(Object*);
	int mainLoop();
	void setBackground(Background*);
	void setAmbient(float,float,float);
	void setFadeQuad(float,float,float,float);
	void setPerspective(float,float,float);
	void setPrimaryView(int,int,int,int,int);
	void setSecondaryView(int,int,int,int,int);
	void setMaxFramerate(float,bool);
	void setDepthFog(bool,float,float,float,float);
	void setCallBack(int,void(*)());
	Font& getFont();
	Camera& getCamera();
};


#endif
